# Copyright

"""Serve cookbooks over HTTP.
"""

import os
import random
import types
from xml.sax import saxutils

import cherrypy
from jinja2 import Environment, FileSystemLoader


class Server (object):
    """Cookbook web interface."""

    def __init__(self, cookbook, template_root):
        self.cookbook = cookbook
        self.cookbook.make_index()
        self.env = Environment(loader=FileSystemLoader(template_root))

    def cleanup(self):
        #self.cookbook.save('new-recipe')
        pass

    @cherrypy.expose
    def index(self, status='open', assignee='all', target='all'):
        """Recipe index page.

        Recipes can be filtered or sorted using a variety of criteria.
        """
        template = self.env.get_template('recipes.html')
        return template.render(cookbook=self.cookbook,
                               recipes=list(self.cookbook))

    @cherrypy.expose
    def recipe(self, name=None):
        """Single recipe page.
        """
        if name == None:
            recipe = random.choice(self.cookbook)
        else:
            if type(name) == types.StringType:
                name = unicode(name, encoding='utf-8')
            recipe = self.cookbook.index[name]
        template = self.env.get_template('recipe.html')
        return template.render(cookbook=self.cookbook, recipe=recipe)
#
#    @cherrypy.expose
#    def create(self, summary):
#        """The view that handles the creation of a new bug."""
#        if summary.strip() != '':
#            bugdir = self.storage_callbacks.get_bugdir()
#            bugdir.new_bug(summary=summary)
#            self.commit(u"Created bug: %s" % summary)
#        raise cherrypy.HTTPRedirect('/', status=302)
#
#    @cherrypy.expose
#    def comment(self, id, body):
#        """The view that handles adding a comment."""
#        if body.strip() != '':
#            bugdir = self.storage_callbacks.get_bugdir()
#            bug = bugdir.bug_from_uuid(id)
#            bug.comment_root.new_reply(body=body)
#            self.commit(u"Added reply Re: %s" % bug.summary)
#            raise cherrypy.HTTPRedirect('/bug?id=%s' % (bug.uuid,), status=302)
#        raise cherrypy.HTTPRedirect('/', status=302)
#
#    @cherrypy.expose
#    def edit(self, id, status=None, target=None, assignee=None, severity=None, summary=None):
#        """The view that handles editing bug details."""
#        bugdir = self.storage_callbacks.get_bugdir()
#        bug = bugdir.bug_from_uuid(id)
#
#        if summary != None:
#            old_summary = bug.summary
#            bug.summary = summary
#            self.bd.vcs.commit("Changed bug summary: %s -> %s" % (old_summary, bug.summary))
#        else:
#            bug.status = status if status != 'None' else None
#            if target != 'None':
#                libbe.target.add_target(bugdir, bug, target)
#            bug.assigned = assignee if assignee != 'None' else None
#            bug.severity = severity if severity != 'None' else None
#            self.bd.vcs.commit("Changed bug values: %s" % bug.summary)
#
#        raise cherrypy.HTTPRedirect('/bug?id=%s' % (bug.uuid,), status=302)

def test():
    import doctest
    doctest.testmod()
